aboutsummaryrefslogtreecommitdiff
path: root/st-urlhandler
diff options
context:
space:
mode:
Diffstat (limited to 'st-urlhandler')
-rwxr-xr-xst-urlhandler19
1 files changed, 19 insertions, 0 deletions
diff --git a/st-urlhandler b/st-urlhandler
new file mode 100755
index 0000000..e2a62f4
--- /dev/null
+++ b/st-urlhandler
@@ -0,0 +1,19 @@
+#!/bin/sh
+
+urlregex="(((http|https|gopher|gemini|ftp|ftps|git)://|www\\.)[a-zA-Z0-9.]*[:]?[a-zA-Z0-9./@$&%?$\#=_~-]*)|((magnet:\\?xt=urn:btih:)[a-zA-Z0-9]*)"
+
+urls="$(sed 's/.*│//g' | tr -d '\n' | # First remove linebreaks and mutt sidebars:
+ grep -aEo "$urlregex" | # grep only urls as defined above.
+ uniq | # Ignore neighboring duplicates.
+ sed "s/\(\.\|,\|;\|\!\\|\?\)$//;
+ s/^www./http:\/\/www\./")" # xdg-open will not detect url without http
+
+[ -z "$urls" ] && exit 1
+
+while getopts "hoc" o; do case "${o}" in
+ h) printf "Optional arguments for custom use:\\n -c: copy\\n -o: xdg-open\\n -h: Show this message\\n" && exit 1 ;;
+ o) chosen="$(echo "$urls" | dmenu -i -p 'Follow which url?' -l 10)"
+ setsid xdg-open "$chosen" >/dev/null 2>&1 & ;;
+ c) echo "$urls" | dmenu -i -p 'Copy which url?' -l 10 | tr -d '\n' | xclip -selection clipboard ;;
+ *) printf "Invalid option: -%s\\n" "$OPTARG" && exit 1 ;;
+esac done